#include "Time.h"
#include "global_include.h"

Time::Time(void) {
	enable_fps = true;
	fps = new char[20];		// should be enough
	is_paused = false;		// is it paused

	// set default value
	frame = 0;
	sprintf(fps, "%d fps", 0);
}

Time::~Time(void)
{
}

void Time::play() {
	is_paused = false;

	last_timestamp = glutGet(GLUT_ELAPSED_TIME);
}

void Time::pause() {
	is_paused = true;
}

void Time::process() {
	int timestamp = glutGet(GLUT_ELAPSED_TIME);

	if (!is_paused && enable_fps == true) {
		frame++;

		if (timestamp - last_timestamp > 500) {
			float fps_ = frame * 500.0 / (timestamp - last_timestamp);

			sprintf(fps, "%.1f fps", fps_);

			// set for next process
			frame = 0;
			last_timestamp = timestamp;
		}
	}
}